package com.syjy.calculate.listener;

import com.googlecode.aviator.AviatorEvaluator;
import com.googlecode.aviator.runtime.JavaMethodReflectionFunctionMissing;
import com.syjy.calculate.function.*;
import org.springframework.boot.context.event.ApplicationStartedEvent;
import org.springframework.context.ApplicationListener;
import org.springframework.stereotype.Component;

@Component
public class ApplicationListenerImpl implements ApplicationListener<ApplicationStartedEvent> {

    @Override
    public void onApplicationEvent(ApplicationStartedEvent event) {
        // 启用基于反射的方法查找和调用
        AviatorEvaluator.setFunctionMissing(JavaMethodReflectionFunctionMissing.getInstance());
        AviatorEvaluator.addFunction(new RootMeanSquaredErrorA());
        AviatorEvaluator.addFunction(new RootMeanSquaredErrorC());
        AviatorEvaluator.addFunction(new RootMeanSquaredErrorS());
        AviatorEvaluator.addFunction(new RootMeanSquaredErrorR());
        AviatorEvaluator.addFunction(new SumDifferenceAbsolute());
        AviatorEvaluator.addFunction(new PointS());
        AviatorEvaluator.addFunction(new PointU());
        AviatorEvaluator.addFunction(new Pass());
        AviatorEvaluator.addFunction(new MeanAbsoluteError());
        AviatorEvaluator.addFunction(new SumDifferenceSquare());
        AviatorEvaluator.addFunction(new ListToListList());
        // (sj-yc)²
        AviatorEvaluator.defineFunction("differenceSquare", "lambda (sj,yc) -> math.pow((sj - yc), 2) end");
        // |sj-yc|
        AviatorEvaluator.defineFunction("differenceAbsolute", "lambda (sj,yc) -> math.abs(sj - yc) end");


    }
}
